	function ws_create_xml(text)
	{
	
		var xmlDoc = null;
	
		try //Internet Explorer
		{
		  xmlDoc=new ActiveXObject("Microsoft.XMLDOM");
		  xmlDoc.async="false";
		  xmlDoc.loadXML(text);
		}
		catch(e)
		{
		  try //Firefox, Mozilla, Opera, etc.
	    {
		    parser=new DOMParser();
		    xmlDoc=parser.parseFromString(text,"text/xml");
	    }
		  catch(e) {}
		}
		return xmlDoc;
	}


	function ws_play_file(file) 
	{
	  //alert(file);
		var voice_div = document.getElementById("voice_div");
		if(voice_div == null)
		{
			voice_div = document.createElement("div");
			voice_div.setAttribute("id","voice_div");
			voice_div.setAttribute('name', 'voice_div');
			voice_div.style.display = "block";
			document.body.appendChild(voice_div);
		};
	
	  var borswer = window.navigator.userAgent.toLowerCase();
	  if(borswer.indexOf( "ie" ) >= 0)
	  {
		  var embed;
		
			embed = document.getElementById('embed_voice');
			
			if (embed != null) 
				voice_div.removeChild(embed);
			
			embed = document.createElement("embed");
			embed.setAttribute('id', 'embed_voice');
			embed.setAttribute('name', 'embed_voice');
			embed.setAttribute('controls', 'smallconsole');
			
			embed.setAttribute('width', 200);
			embed.setAttribute('height',200);
			
			embed.setAttribute('src', file);
			embed.setAttribute('hidden', false);
			embed.setAttribute('autostart', true);
			voice_div.appendChild(embed);
		}
		else
		{
		  var audio;
		
			audio = document.getElementById('audio_voice');
			
			if (audio != null) 
				voice_div.removeChild(audio);
			
			audio = document.createElement("audio");
			audio.setAttribute('id', 'audio_voice');
			audio.setAttribute('name', 'audio_voice');
			audio.setAttribute('src', file);
			audio.setAttribute('hidden', false);
			audio.setAttribute('width', 200);
			audio.setAttribute('height',200);
	
			voice_div.appendChild(audio);
			//audio.load();
			audio.play();
		};
	}
	


  var Web_Socket;
  var Web_Socket_Is_App=0;
  var Web_Socket_Connected=0;

  function ws_Connect(host) 
  {
  	//alert('ws_Connect');
   	if(Web_Socket_Connected) return;
  	//alert('ws_Connect1');
    try 
    {
      if ("WebSocket" in window) 
      {
      	Web_Socket = new WebSocket("ws://" + host);
      }
      else if("MozWebSocket" in window) 
      {
      	Web_Socket = new MozWebSocket("ws://" + host);
      }
    } 
    catch (ex) 
    {
        alert("connect fail to "+host);
        return;
    }
    
    Web_Socket.onopen = ws_onOpen;
    Web_Socket.onmessage = ws_onMessage;
    Web_Socket.onclose = ws_onClose;
    Web_Socket.onerror = ws_onError;
   	//alert('ws_Connect2');
 }

  function ws_onOpen() 
  {
	    //ws.send("login:" + document.getElementById("txtName").value);
    Web_Socket_Connected=1;
  	//alert('ws_open');
  	if(Web_Socket_Is_App)
			window.location.href=encodeURI('/app_func?func_id=check_log');
  };


	function ws_get_Xml_Node_Value(xml,id)
	{
		if(xml.getElementsByTagName(id)==null)
			return null;
		if(xml.getElementsByTagName(id)[0]==null)
			return null;
		if(xml.getElementsByTagName(id)[0].childNodes==null)
			return null;
		if(xml.getElementsByTagName(id)[0].childNodes[0]==null)
			return null;
			
		return xml.getElementsByTagName(id)[0].childNodes[0].nodeValue;
	};
	
  /*
  function otification_construct()
  {

      var notification = new Notification('յʼ', {
          body: '1ѩδʼ',
          dir: "auto",
          lang:"zh-CN",
          tag: "a1",
          icon:"../../images/headerPic/772513932673948130.jpg"
      });
      console.log(notification.title); // "յʼ"
      console.log(notification.body); // "ܹ3δʼ"
  }
*/
	function ws_std_uri_to_para(uri)
	{

			  	var log2=uri.replace(/#/g,"^1");
					log2=log2.replace(/\=/g,  "^2");
					log2=log2.replace(/</g,   "^3");
					log2=log2.replace(/>/g,   "^4");
					log2=log2.replace(/\//g,  "^5");
					log2=log2.replace(/\"/g,  "^6");
					log2=log2.replace(/\'/g,  "^7");
					log2=log2.replace(/\?/g,  "^8");
					return log2;
	};

	function ws_std_para_to_uri(cmd)
	{
		//alert("ws_Append_Log2 called");

  	var log2=cmd.replace(/\^1/g,"#");
		log2=log2.replace(/\^2/g,  "=");
		log2=log2.replace(/\^3/g,   "<");
		log2=log2.replace(/\^4/g,   ">");
		log2=log2.replace(/\^5/g,  "/");
		log2=log2.replace(/\^6/g,  "\"");
		log2=log2.replace(/\^7/g,  "'");
		log2=log2.replace(/\^8/g,  "?");

		return log2;
	};


	function ws_request_app_locate(uri)
	{
		//alert('ws_request_app_locate '+uri);
	  if(!Web_Socket_Is_App) return;

		window.location.href=encodeURI('/app_func?func_id=nag&uri='+ws_std_uri_to_para(uri));
	};

	function ws_App_Request_Go(para)
	{
		//alert('ws_App_Request_Go '+para);
	  //if(!Web_Socket_Is_App) return;
		
		var uri=ws_std_para_to_uri(para);
		
		//uri = 'm_voucher_info?voucher_id=105';
		//alert('after convert uri is '+uri);
		window.location.href=uri;
	};


  function ws_onMessage(event) 
  {
      // Log(event.data); 
      //alert(event.data);  
      
      //ws_Log(event.data); 
      
         
      //play('ring.wav');  
      //iphone޷Զŵ
      
      //return;
      
      var xml;


      xml = ws_create_xml(event.data);
			
			
			var log;
			
			var cmd =  ws_get_Xml_Node_Value(xml,"_msg_");

			/*
			var cmd;
			cmd = xml.getElementsByTagName("_msg_")[0].childNodes[0].nodeValue;
			*/
			//alert(cmd);
			
			//ỰϢ
			if(cmd=='tm_chat')
			{
			  //var send_user_id =  xml.getElementsByTagName("send_user_id")[0].childNodes[0].nodeValue;
			  var send_user_id =  ws_get_Xml_Node_Value(xml,"send_user_id");
			  var send_time =  ws_get_Xml_Node_Value(xml,"send_time");
			  var obj_type =  ws_get_Xml_Node_Value(xml,"obj_type");
			  var obj_id =  ws_get_Xml_Node_Value(xml,"obj_id");
			  var msg_info =  ws_get_Xml_Node_Value(xml,"msg_info");
			  var msg_id =  ws_get_Xml_Node_Value(xml,"msg_id");

				log = send_time+' ';
      	log = log + ' <a href="#popupLogin" onclick="ws_Log_Pop_Send_Win(' + "'" + send_user_id+ "'"+')" data-rel="popup" data-transition="pop" data-position-to="window"><font color=green>'+send_user_id+'</font></a>';
				log = log + ': '+msg_info;

				//alert(log);
			  if(obj_type=='voucher')
			  {
			  	//log = log + '<a href="m_voucher_info?voucher_id=' + obj_id + '">򿪵</a>';
			  	
			  	if(Web_Socket_Is_App)
			  	{
			  	  log = log + '<a href="javascript:void(0);" onclick="ws_request_app_locate(';
			  	  log = log + "'";                                    
			  	  log = log + 'm_voucher_info?voucher_id=' + obj_id;
			  	  log = log + "'";
			  	  log = log + ')"><font color=green>򿪵</font></a>';
					}
					else
					{
						log = log + '<a href="m_voucher_info?voucher_id=' + obj_id + '">򿪵</a>';
					};
			  	//alert(log);
			  };
				log = log + '<br><br>';
		  
			  ws_Log(log);
			  
				//window.location.href='/app_func?func_id=notify&msg=msgcome';
			  if(Web_Socket_Is_App)
			  {
			  	var log2=log.replace(/#/g,"^1");
					log2=log2.replace(/\=/g,  "^2");
					log2=log2.replace(/</g,   "^3");
					log2=log2.replace(/>/g,   "^4");
					log2=log2.replace(/\//g,  "^5");
					log2=log2.replace(/\"/g,  "^6");
					log2=log2.replace(/\'/g,  "^7");
					log2=log2.replace(/\?/g,  "^8");
					
			  	//alert(log2);
					window.location.href=encodeURI('/app_func?func_id=notify&msg='+msg_info+'&log='+log2+'&msg_id='+msg_id);
			  };
			  
			  //msg_info
			  //ws_play_file('/m.wav/s_di.wav');
			  
			};

			if(cmd=='play_file')
			{
				var file;
			
				file = ws_get_Xml_Node_Value(xml,"file"); 
				ws_play_file(file);
			};
			
			if(cmd=='alert')
			{
				var msg;
			
				msg = ws_get_Xml_Node_Value(xml,"msg");  
				alert(msg);
			};
  };

  function ws_onClose() 
  {
  	  //ws_play_file('ring.wav'); 
  	  //alert('net closed22');
  	  Web_Socket.close();
	    Web_Socket_Connected=0;
  	  ws_Init();
  };


  function ws_onError() 
  {
	  	//alert('net error33');
  		//ws_Init();
  };

  function ws_Send(data) 
  {
      Web_Socket.send(data);
  };

  function ws_Log_Div_Check() 
  {
  	var log_div = document.getElementById("ws_log_div");
		if(log_div != null) return;

		var div_header = document.getElementById("div_header");
		if(div_header==null) return;

		log_div = document.createElement("div");
		log_div.setAttribute("id","ws_log_div");
		log_div.setAttribute('name', 'ws_log_div');
		log_div.setAttribute('data-role', 'fieldcontain');
		log_div.setAttribute('style', 'display:block;overflow:auto');
		//data-role="fieldcontain"

		div_header.appendChild(log_div);

		//alert(log_div.innerHTML);
		
		var h;
		
		h = '';
		if(Web_Socket_Is_App==0)
    {
    	h = h + '  <div style="margin-top:0px;">';
	    h = h + '      <div class="ui-grid-a" >';
	    h = h + '          <div class="ui-block-a"><button type="button" data-theme="a" onclick="ws_Log_Hide()"></button></div>';
	    h = h + '          <div class="ui-block-b"><button type="button" data-theme="a" onclick="ws_Log_Zoom()">С</button></div>';
	    h = h + '      </div>';
	    
	    h = h + '  </div>';
 	 };
  
    
    
    //h = h + '  <textarea  type="text" style="resize:none;" name="ws_log" id="ws_log"></textarea>';

    h = h + '  <div class="ui-corner-all" id="popupLogin" name="popupLogin" data-role="popup" data-theme="a">';
    h = h + '      <form>';
    h = h + '          <div style="padding: 10px 20px;">';
    h = h + '              <h3>Ϣ</h3>';
    h = h + '              <label class="ui-hidden-accessible" for="chat_target">Է:</label>';
    h = h + '              <input name="chat_target" id="chat_target" type="text" placeholder="Է" value="" data-theme="a">';
    h = h + '              <label class="ui-hidden-accessible" for="chat_msg">:</label>';
    h = h + '              <input name="chat_msg" id="chat_msg" type="text" placeholder="" value="" data-theme="a">';
    h = h + '              <button class="ui-btn ui-corner-all ui-shadow ui-btn-b ui-btn-icon-left ui-icon-check" type="button" onclick="ws_Send_To_User()"></button>';
    h = h + '          </div>';
    h = h + '      </form>';
    h = h + '  </div>';


		//h = h + '<div style="height:100px;overflow:auto" id="ws_log_tab_div" name="ws_log_tab_div">';
		h = h + '<div style="overflow:auto" id="ws_log_tab_div" name="ws_log_tab_div">';
		
  	//h = h + '  <table width=100% style="height:100px;font-size:16px;" id="tab_log" name="tab_log">';
  	
  	h = h + '  <table width=100% height=100% style="font-size:16px;" id="tab_log" name="tab_log">';
  	h = h + '    <tr>';
    h = h + '        <td style="width:100%">Ϣ</td>';
    h = h + '    </tr>';
    h = h + '  </table>';
    h = h + '  </div>';

 		log_div.innerHTML = h;
  	

  	$("#div_header").trigger("create");


		log_div.style.display = "block";

	};

  function ws_Log(msg) 
  {
  
		//  	alert('log '+msg);
		var log_div = document.getElementById("ws_log_div");
		
		if(log_div == null) 
		{
			ws_Log_Div_Check();
			log_div = document.getElementById("ws_log_div");
		}
	
		if(log_div == null) return;
		
		var div_header = document.getElementById("div_header");
		if(div_header==null) return;


		log_div.style.display = "block";
		
		var $tr=$("<tr><td>" + msg + "</td></tr>");       
		
		$tr.appendTo("#tab_log");

		var ws_log_tab_div = document.getElementById("ws_log_tab_div");
		if(ws_log_tab_div != null)
			ws_log_tab_div.scrollTop = ws_log_tab_div.scrollHeight;
	
		return;

  };

  function ws_Send_To_User() 
  {
  	var user_id=document.getElementById("chat_target").value
  	var chat_msg=document.getElementById("chat_msg").value
  	
  	//alert("send "+chat_msg+" to "+user_id);
		
  	var log_div = document.getElementById("popupLogin");
		if(log_div == null) return;
		log_div.style.display = "none";


		var data;  
		data = '<?xml version="1.0" encoding="utf-8"?>';   
		data = data + '<para_mgr type="para">';   
		data = data + '<recv_user_id type="string">' + user_id +'</recv_user_id>';   
		//data = data + '<send_user_id type="string">' + 'admin' +'</send_user_id>';   
		data = data + '<msg_info type="string">' + chat_msg +'</msg_info>';   
		data = data + '</para_mgr>">';   
		
  	//alert("send begin");
		var ret_xml = new m_xml_call("http_xml_call?func_id=_Chat_",data);
  	//alert("send over");

		//ws_Loop_Play();
	};

  function ws_Loop_Play() 
  { 
  	//alert('ws_Loop_Play');
		//ws_play_file('/m.wav/s_di.wav');
  	//setTimeout('ws_Loop_Play()',3000); 
  } 


  function ws_Log_Hide() 
  {
  	var log_div = document.getElementById("ws_log_div");
		if(log_div == null) return;
		log_div.style.display = "none";
		//ws_play_file('/m.wav/s_di.wav');
		
		//ws_Loop_Play();
	};

  function ws_Log_Show() 
  {
  	ws_Log_Div_Check();
  	
  	var log_div = document.getElementById("ws_log_div");
		if(log_div == null) return;
		log_div.style.display = "";
		ws_Set_Log_Size(300);
	};


  function ws_Log_Pop_Send_Win(send_user_id) 
  {
		//alert('a');
		//location.href='#popupLogin';

		//alert(send_user_id);
		$("#chat_target").val(send_user_id);
		$("#chat_msg").val('');
		
	 	var log_div = document.getElementById("popupLogin");
		if(log_div == null) return;
		log_div.style.display = "";

	// $('.popupLogin').css('display', 'block');
		 
  	/*
  	var log_div = document.getElementById("popupLogin");
		if(log_div == null) return;
		log_div.style.display = "block";
		alert('b');
		*/
		//ws_play_file('/m.wav/s_di.wav');
		
		//ws_Loop_Play();
	};

  function ws_Log_Zoom() 
  {
  	var log_div = document.getElementById("ws_log_div");
		if(log_div == null) return;
		
		var h;
		
		h = log_div.offsetHeight;
		if(h==null)
			h=300;
		if(h>=300)
			h=100;
		else
			h=300;
			
		ws_Set_Log_Size(h);

	};

  function ws_Set_Log_Size(h) 
  {
  	var log_div = document.getElementById("ws_log_div");
		if(log_div == null) return;
		
		log_div.style.height = h+'px';
		
	
  	var ws_log_tab_div = document.getElementById("ws_log_tab_div");
		if(ws_log_tab_div == null) return;
		
		ws_log_tab_div.style.height = (h-55)+'px';
		
	  var log;
	
 		log = document.getElementById('tab_log');
		if(log == null) return;
		log.style.height = (h-35)+'px';
    $("#div_header").trigger("create");
    $("#ws_log").trigger("create");
    $("#ws_log_div").trigger("create");
    
	};

	function ws_Init()
	{
		if(Web_Socket_Connected) return;
		
		var hostname = location.hostname;
		var port = location.port;

		ws_Connect(hostname+':'+port+'/_msg_');
	};
	
	function ws_App_Append_Log(cmd)
	{
		//alert("ws_Append_Log2 called");

  	var log2=cmd.replace(/\^1/g,"#");
		log2=log2.replace(/\^2/g,  "=");
		log2=log2.replace(/\^3/g,   "<");
		log2=log2.replace(/\^4/g,   ">");
		log2=log2.replace(/\^5/g,  "/");
		log2=log2.replace(/\^6/g,  "\"");
		log2=log2.replace(/\^7/g,  "'");
		log2=log2.replace(/\^8/g,  "?");


		//var log=decodeURIComponent(cmd);
		//alert(log2);
		ws_Log(log2);
	};
	

	function ws_App_Set_Log_Div(display,h)
	{
		//alert("ws_App_Set_Log_Div "+display+","+h);
  	var log_div = document.getElementById("ws_log_div");
		if(log_div == null) return;
		
		log_div.style.display = display;

		ws_Set_Log_Size(h);
	};

  function ws_Check_Chat_Msg(msg_id) 
  {
		var data;  
		data = '<?xml version="1.0" encoding="utf-8"?>';   
		data = data + '<para_mgr type="para">';   
		data = data + '<min_msg_id type="string">' + msg_id +'</min_msg_id>';   
		data = data + '</para_mgr>">';   
		
  	//alert("send begin");
		var ret_xml = new m_xml_call("http_xml_call?func_id=_Ws_Chat_Check_",data);
  	//alert("send over");

		//ws_Loop_Play();
	};
